(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     30006,        913]
NotebookOptionsPosition[     27509,        831]
NotebookOutlinePosition[     27856,        846]
CellTagsIndexPosition[     27813,        843]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", "\[IndentingNewLine]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.537493720607201*^9, 3.537493721270239*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"<<", "robotica.m"}], ";"}]], "Input",
 CellChangeTimes->{{3.5344018124808593`*^9, 3.5344018159708643`*^9}, 
   3.5345461879146166`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DataFile", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"DataFile\\\"\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple contexts \
\\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"robotica`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"robotica`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"robotica`DataFile::shdw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5345439034558754`*^9, 3.537493447545261*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FKin", "::", "\<\"shdw\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Symbol \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"FKin\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" appears in multiple \
contexts \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({\\\"robotica`\\\", \
\\\"Global`\\\"}\\), \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\"; \
definitions in context \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(\\\"robotica`\\\"\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" may shadow or be \
shadowed by other definitions.\\\\\\\"\\\", \\\"MT\\\"]\\) \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/General/shdw\\\", \
ButtonNote -> \\\"robotica`FKin::shdw\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5345439034558754`*^9, 3.537493447577263*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Robotica version \"\>", "\[InvisibleSpace]", "\<\"3.62\"\>", 
   "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm["Robotica version ", "3.62", "."],
  Editable->False]], "Print",
 CellChangeTimes->{3.537493447580263*^9}],

Cell[BoxData["\<\"Copyright 1993 Board of Trustees, University of \
Illinois\"\>"], "Print",
 CellChangeTimes->{3.537493447582263*^9}],

Cell[BoxData["\<\"All rights reserved.\"\>"], "Print",
 CellChangeTimes->{3.5374934475852633`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Email questions, comments, or concerns to \"\>", 
   "\[InvisibleSpace]", "\<\"m-spong@uiuc.edu\"\>", 
   "\[InvisibleSpace]", "\<\".\"\>"}],
  SequenceForm[
  "Email questions, comments, or concerns to ", "m-spong@uiuc.edu", "."],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934475882635`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DataFile", "[", 
  "\"\<C:\\\\Users\\\\User\\\\Desktop\\ICs\\\\robotTools\\\\DHparams.txt\>\"",
   "]"}], "\[IndentingNewLine]", 
 RowBox[{"FKin", "[", "]"}]}], "Input",
 CellChangeTimes->{{3.5344018346108894`*^9, 3.5344018373508935`*^9}, {
  3.5344019424051228`*^9, 3.5344020061252103`*^9}, {3.5345461663153815`*^9, 
  3.5345461667254047`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"No dynamics data found.\"\>"], "Print",
 CellChangeTimes->{3.5374934563357058`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934563377056`*^9}],

Cell[BoxData["\<\"Kinematics Input Data\"\>"], "Print",
 CellChangeTimes->{3.537493456340706*^9}],

Cell[BoxData["\<\"---------------------\"\>"], "Print",
 CellChangeTimes->{3.537493456343706*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934563467064`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   InterpretationBox[GridBox[{
      {"\<\"Joint\"\>"},
      {"\<\" \"\>"},
      {"1"},
      {"2"},
      {"3"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"Joint", " ", 1, 2, 3}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"   \"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"   "}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"Type\"\>"},
      {"\<\" \"\>"},
      {"\<\"revolute\"\>"},
      {"\<\"revolute\"\>"},
      {"\<\"revolute\"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"Type", " ", "revolute", "revolute", "revolute"}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"   \"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"   "}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"a\"\>"},
      {"\<\" \"\>"},
      {
       StyleBox["seg1length",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["seg2length",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["seg3length",
        ShowStringCharacters->True,
        NumberMarks->True]}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"a", " ", 
      FortranForm[$CellContext`seg1length], 
      FortranForm[$CellContext`seg2length], 
      FortranForm[$CellContext`seg3length]}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"   \"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"   "}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"alpha\"\>"},
      {"\<\" \"\>"},
      {
       StyleBox[
        RowBox[{"90", "*", "Degree"}],
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["0",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["0",
        ShowStringCharacters->True,
        NumberMarks->True]}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"alpha", " ", 
      FortranForm[90 Degree], 
      FortranForm[0], 
      FortranForm[0]}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"   \"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"   "}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"d\"\>"},
      {"\<\" \"\>"},
      {
       StyleBox["0",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["0",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["0",
        ShowStringCharacters->True,
        NumberMarks->True]}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"d", " ", 
      FortranForm[0], 
      FortranForm[0], 
      FortranForm[0]}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"   \"\>"}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"   "}],
    Editable->False], "\[InvisibleSpace]", 
   InterpretationBox[GridBox[{
      {"\<\"theta\"\>"},
      {"\<\" \"\>"},
      {
       StyleBox["q1",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["q2",
        ShowStringCharacters->True,
        NumberMarks->True]},
      {
       StyleBox["q3",
        ShowStringCharacters->True,
        NumberMarks->True]}
     },
     BaselinePosition->{Baseline, {1, 1}},
     GridBoxAlignment->{
      "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
       "RowsIndexed" -> {}}],
    ColumnForm[{"theta", " ", 
      FortranForm[$CellContext`q1], 
      FortranForm[$CellContext`q2], 
      FortranForm[$CellContext`q3]}],
    Editable->False]}],
  SequenceForm[
   ColumnForm[{"Joint", " ", 1, 2, 3}], 
   ColumnForm[{"   "}], 
   ColumnForm[{"Type", " ", "revolute", "revolute", "revolute"}], 
   ColumnForm[{"   "}], 
   ColumnForm[{"a", " ", 
     FortranForm[$CellContext`seg1length], 
     FortranForm[$CellContext`seg2length], 
     FortranForm[$CellContext`seg3length]}], 
   ColumnForm[{"   "}], 
   ColumnForm[{"alpha", " ", 
     FortranForm[90 Degree], 
     FortranForm[0], 
     FortranForm[0]}], 
   ColumnForm[{"   "}], 
   ColumnForm[{"d", " ", 
     FortranForm[0], 
     FortranForm[0], 
     FortranForm[0]}], 
   ColumnForm[{"   "}], 
   ColumnForm[{"theta", " ", 
     FortranForm[$CellContext`q1], 
     FortranForm[$CellContext`q2], 
     FortranForm[$CellContext`q3]}]],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563517065`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.537493456354707*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.537493456357707*^9}],

Cell[BoxData["\<\"A Matrices Formed :\"\>"], "Print",
 CellChangeTimes->{3.5374934563607073`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934563637075`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A[\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["A[", 1, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563667073`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A[\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["A[", 2, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563697076`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"A[\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["A[", 3, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563727074`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.537493456376708*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934563797083`*^9}],

Cell[BoxData["\<\"T Matrices Formed :\"\>"], "Print",
 CellChangeTimes->{3.5374934563827085`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934563867083`*^9}],

Cell[BoxData["\<\"T[0,0]\"\>"], "Print",
 CellChangeTimes->{3.5374934563897085`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 0, ",", 1, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.537493456391709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 0, ",", 2, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563937087`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "0", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 0, ",", 3, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563967094`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 1, ",", 2, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934563987093`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "1", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 1, ",", 3, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.537493456400709*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"T[\"\>", "\[InvisibleSpace]", "2", 
   "\[InvisibleSpace]", "\<\",\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\"]\"\>"}],
  SequenceForm["T[", 2, ",", 3, "]"],
  Editable->False]], "Print",
 CellChangeTimes->{3.53749345641371*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934564257107`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934564377117`*^9}],

Cell[BoxData["\<\"Jacobian Formed : \"\>"], "Print",
 CellChangeTimes->{3.537493456449712*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.537493456462713*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Jacobian  J\"\>", "\[InvisibleSpace]", "\<\"(6\"\>", 
   "\[InvisibleSpace]", "\<\"x\"\>", "\[InvisibleSpace]", "3", 
   "\[InvisibleSpace]", "\<\")\"\>"}],
  SequenceForm["Jacobian  J", "(6", "x", 3, ")"],
  Editable->False]], "Print",
 CellChangeTimes->{3.5374934564747133`*^9}],

Cell[BoxData["\<\" \"\>"], "Print",
 CellChangeTimes->{3.5374934564867144`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Find equation for foot position. This is done by converting the point \
(0,0,0), i.e. the tip of the foot, to the world coordinate frame.\
\>", "Subsubtitle",
 CellChangeTimes->{{3.5345460527016296`*^9, 3.5345460590666676`*^9}, {
  3.537493579326991*^9, 3.537493646404414*^9}, {3.537493882205457*^9, 
  3.537493962804574*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Clear", "[", 
  RowBox[{"q1", ",", "q2", ",", "q3"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"coords", "=", 
   RowBox[{"Transpose", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"footposition", " ", "=", " ", 
  RowBox[{"MatrixForm", "[", 
   RowBox[{"Simplify", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"A", "[", "1", "]"}], ".", 
      RowBox[{"A", "[", "2", "]"}], ".", 
      RowBox[{"A", "[", "3", "]"}], ".", "coords"}], ",", " ", 
     RowBox[{"Element", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"q1", ",", "q2", ",", "q3"}], "}"}], ",", " ", "Reals"}], 
      "]"}]}], "]"}], "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5344046169447746`*^9, 3.534404671559963*^9}, {
   3.534543861135817*^9, 3.5345438956558647`*^9}, {3.534543941135927*^9, 
   3.5345439442459316`*^9}, {3.5345440365060587`*^9, 
   3.5345440649960985`*^9}, {3.5345441101561604`*^9, 
   3.5345441118661633`*^9}, {3.534544463936649*^9, 3.5345444715366592`*^9}, {
   3.53454455900928*^9, 3.534544609099349*^9}, 3.5345460791937833`*^9, {
   3.534546133897915*^9, 3.53454615195794*^9}, {3.534546337870118*^9, 
   3.534546383723236*^9}, {3.5345465831837125`*^9, 3.5345465860137167`*^9}, 
   3.534546617205817*^9, {3.5345467890726895`*^9, 3.534546857766066*^9}, {
   3.5345468940743084`*^9, 3.534546902137375*^9}, 3.534548172204889*^9, {
   3.5345487919174557`*^9, 3.534548792787457*^9}, {3.534548843779584*^9, 
   3.534548847619589*^9}, {3.537493422029954*^9, 3.5374934238130484`*^9}, {
   3.537493508059352*^9, 3.5374935180738597`*^9}, {3.5374935815941067`*^9, 
   3.537493581993122*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"Cos", "[", "q1", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"seg1length", "+", 
         RowBox[{"seg2length", " ", 
          RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
         RowBox[{"seg3length", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}]},
     {
      RowBox[{
       RowBox[{"(", 
        RowBox[{"seg1length", "+", 
         RowBox[{"seg2length", " ", 
          RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
         RowBox[{"seg3length", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}], " ", 
       RowBox[{"Sin", "[", "q1", "]"}]}]},
     {
      RowBox[{
       RowBox[{"seg2length", " ", 
        RowBox[{"Sin", "[", "q2", "]"}]}], "+", 
       RowBox[{"seg3length", " ", 
        RowBox[{"Sin", "[", 
         RowBox[{"q2", "+", "q3"}], "]"}]}]}]},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.5344046446278696`*^9, 3.5344046719699636`*^9}, {
   3.534543869995829*^9, 3.534543945215933*^9}, {3.5345440416860657`*^9, 
   3.5345440659660997`*^9}, 3.534544112646164*^9, 3.534544472606661*^9, {
   3.534544551319269*^9, 3.53454460952935*^9}, 3.5345455419578443`*^9, 
   3.5345460837237897`*^9, {3.5345461203978963`*^9, 3.5345461530779414`*^9}, {
   3.5345462016144004`*^9, 3.5345462150391684`*^9}, {3.5345463294501066`*^9, 
   3.534546383983237*^9}, 3.534546587303718*^9, 3.5345466175758176`*^9, {
   3.534546791413726*^9, 3.534546858536067*^9}, 3.534546903167376*^9, {
   3.5345481631648765`*^9, 3.5345481725148892`*^9}, {3.534548768104357*^9, 
   3.534548793567458*^9}, 3.53454884817959*^9, {3.5374934912324915`*^9, 
   3.537493518914903*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
For testing, input joint angles here and it will spit out foot position:\
\>", "Subsubtitle",
 CellChangeTimes->{{3.537493521461032*^9, 3.537493522823102*^9}, {
  3.53749370346833*^9, 3.5374937113957324`*^9}, {3.5374938653596015`*^9, 
  3.537493874004039*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"transformation", "[", 
    RowBox[{"q1_", ",", "q2_", ",", "q3_"}], "]"}], "=", "footposition"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"transformation", "[", 
  RowBox[{
   RowBox[{"Pi", "/", "2"}], ",", 
   RowBox[{"Pi", "/", "2"}], ",", "0"}], "]"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0"},
     {"seg1length"},
     {
      RowBox[{"seg2length", "+", "seg3length"}]},
     {"1"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{3.5374938625134544`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\




The Jacobian matrix can also be found analytically, but it's so long that \
I've decided to not use this and just find it numerically in the program\
\>", "Subsubtitle",
 CellChangeTimes->{{3.5374936866484694`*^9, 3.5374936888375797`*^9}, {
  3.537493787923645*^9, 3.5374938528449593`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", "J", "]"}]], "Input",
 CellChangeTimes->{{3.534555637089715*^9, 3.5345556441397247`*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{"seg1length", "+", 
          RowBox[{"seg2length", " ", 
           RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
          RowBox[{"seg3length", " ", 
           RowBox[{"Cos", "[", 
            RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}], " ", 
       RowBox[{"Sin", "[", "q1", "]"}]}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Cos", "[", "q1", "]"}]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"seg2length", " ", 
          RowBox[{"Sin", "[", "q2", "]"}]}], "+", 
         RowBox[{"seg3length", " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "seg3length"}], " ", 
       RowBox[{"Cos", "[", "q1", "]"}], " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"q2", "+", "q3"}], "]"}]}]},
     {
      RowBox[{
       RowBox[{"Cos", "[", "q1", "]"}], " ", 
       RowBox[{"(", 
        RowBox[{"seg1length", "+", 
         RowBox[{"seg2length", " ", 
          RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
         RowBox[{"seg3length", " ", 
          RowBox[{"Cos", "[", 
           RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"Sin", "[", "q1", "]"}]}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"seg2length", " ", 
          RowBox[{"Sin", "[", "q2", "]"}]}], "+", 
         RowBox[{"seg3length", " ", 
          RowBox[{"Sin", "[", 
           RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}], 
      RowBox[{
       RowBox[{"-", "seg3length"}], " ", 
       RowBox[{"Sin", "[", "q1", "]"}], " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"q2", "+", "q3"}], "]"}]}]},
     {"0", 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "q1", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "seg1length"}], " ", 
           RowBox[{"Cos", "[", "q1", "]"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", "q1", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"seg1length", "+", 
             RowBox[{"seg2length", " ", 
              RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
             RowBox[{"seg3length", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", "q1", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "seg1length"}], " ", 
           RowBox[{"Sin", "[", "q1", "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"seg1length", "+", 
             RowBox[{"seg2length", " ", 
              RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
             RowBox[{"seg3length", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}], " ", 
           RowBox[{"Sin", "[", "q1", "]"}]}]}], ")"}]}]}], 
      RowBox[{
       RowBox[{
        RowBox[{"Cos", "[", "q1", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"Cos", "[", "q1", "]"}]}], " ", 
           RowBox[{"(", 
            RowBox[{"seg1length", "+", 
             RowBox[{"seg2length", " ", 
              RowBox[{"Cos", "[", "q2", "]"}]}]}], ")"}]}], "+", 
          RowBox[{
           RowBox[{"Cos", "[", "q1", "]"}], " ", 
           RowBox[{"(", 
            RowBox[{"seg1length", "+", 
             RowBox[{"seg2length", " ", 
              RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
             RowBox[{"seg3length", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}]}]}], ")"}]}], "+", 
       RowBox[{
        RowBox[{"Sin", "[", "q1", "]"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"seg1length", "+", 
              RowBox[{"seg2length", " ", 
               RowBox[{"Cos", "[", "q2", "]"}]}]}], ")"}]}], " ", 
           RowBox[{"Sin", "[", "q1", "]"}]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"seg1length", "+", 
             RowBox[{"seg2length", " ", 
              RowBox[{"Cos", "[", "q2", "]"}]}], "+", 
             RowBox[{"seg3length", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"q2", "+", "q3"}], "]"}]}]}], ")"}], " ", 
           RowBox[{"Sin", "[", "q1", "]"}]}]}], ")"}]}]}]},
     {"0", 
      RowBox[{"Sin", "[", "q1", "]"}], 
      RowBox[{"Sin", "[", "q1", "]"}]},
     {"0", 
      RowBox[{"-", 
       RowBox[{"Cos", "[", "q1", "]"}]}], 
      RowBox[{"-", 
       RowBox[{"Cos", "[", "q1", "]"}]}]},
     {"1", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.5345556382697167`*^9, 3.5345556446297255`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"JTinv", " ", "=", " ", 
  RowBox[{"PseudoInverse", "[", "J", "]"}]}]], "Input",
 CellChangeTimes->{{3.534563295770337*^9, 3.5345633379903955`*^9}}],

Cell["\<\





For backup, here' s the text file DHparams.txt :


Some notes:
z0 is the axis of actuation for joint 1, z1 is the axis for joint 2, etc.
For my robot specifically, the +x0 axis is toward the front of the robot, the \
+y is toward the left.
Note: the transformation matrices T[0,3] appear to not work, so make it \
yourself with A[1].A[2].A[3]
DOF=3
(Robotica requires a line of comment text between DOF and joint1)  -90 Degree
joint1 = revolute
a1 = seg1length
alpha1 = 90 Degree
d1 = 0
theta1 = q1
joint2 = revolute
a2 = seg2length
alpha2 = 0
d2 = 0
theta2 = q2
joint3 = revolute
a3 = seg3length
alpha3 = 0
d3 = 0
theta3 = q3\
\>", "Text",
 CellChangeTimes->{{3.5374937578651075`*^9, 3.5374937810482955`*^9}, {
  3.5374938560061183`*^9, 3.537493856710159*^9}}]
}, Open  ]]
},
WindowSize->{1313, 928},
WindowMargins->{{108, Automatic}, {11, Automatic}},
FrontEndVersion->"7.0 for Microsoft Windows (64-bit) (November 10, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 172, 3, 92, "Input"],
Cell[CellGroupData[{
Cell[742, 27, 170, 4, 31, "Input"],
Cell[915, 33, 1012, 17, 21, "Message"],
Cell[1930, 52, 1000, 17, 21, "Message"],
Cell[CellGroupData[{
Cell[2955, 73, 271, 6, 23, "Print"],
Cell[3229, 81, 134, 2, 23, "Print"],
Cell[3366, 85, 98, 1, 23, "Print"],
Cell[3467, 88, 354, 8, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3870, 102, 370, 7, 52, "Input"],
Cell[CellGroupData[{
Cell[4265, 113, 101, 1, 23, "Print"],
Cell[4369, 116, 79, 1, 23, "Print"],
Cell[4451, 119, 97, 1, 23, "Print"],
Cell[4551, 122, 97, 1, 23, "Print"],
Cell[4651, 125, 79, 1, 23, "Print"],
Cell[4733, 128, 6128, 200, 83, "Print"],
Cell[10864, 330, 77, 1, 23, "Print"],
Cell[10944, 333, 77, 1, 23, "Print"],
Cell[11024, 336, 97, 1, 23, "Print"],
Cell[11124, 339, 79, 1, 23, "Print"],
Cell[11206, 342, 227, 6, 23, "Print"],
Cell[11436, 350, 227, 6, 23, "Print"],
Cell[11666, 358, 227, 6, 23, "Print"],
Cell[11896, 366, 77, 1, 23, "Print"],
Cell[11976, 369, 79, 1, 23, "Print"],
Cell[12058, 372, 97, 1, 23, "Print"],
Cell[12158, 375, 79, 1, 23, "Print"],
Cell[12240, 378, 84, 1, 23, "Print"],
Cell[12327, 381, 297, 7, 23, "Print"],
Cell[12627, 390, 299, 7, 23, "Print"],
Cell[12929, 399, 299, 7, 23, "Print"],
Cell[13231, 408, 299, 7, 23, "Print"],
Cell[13533, 417, 297, 7, 23, "Print"],
Cell[13833, 426, 296, 7, 23, "Print"],
Cell[14132, 435, 79, 1, 23, "Print"],
Cell[14214, 438, 79, 1, 23, "Print"],
Cell[14296, 441, 94, 1, 23, "Print"],
Cell[14393, 444, 77, 1, 23, "Print"],
Cell[14473, 447, 329, 7, 23, "Print"],
Cell[14805, 456, 79, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14933, 463, 336, 6, 28, "Subsubtitle"],
Cell[CellGroupData[{
Cell[15294, 473, 1753, 36, 92, "Input"],
Cell[17050, 511, 2231, 54, 86, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19330, 571, 270, 5, 28, "Subsubtitle"],
Cell[CellGroupData[{
Cell[19625, 580, 317, 9, 52, "Input"],
Cell[19945, 591, 697, 21, 86, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20691, 618, 304, 9, 104, "Subsubtitle"],
Cell[CellGroupData[{
Cell[21020, 631, 131, 2, 31, "Input"],
Cell[21154, 635, 5374, 151, 102, "Output"]
}, Open  ]],
Cell[26543, 789, 171, 3, 31, "Input"],
Cell[26717, 794, 776, 34, 533, "Text"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
